;**** Udskrivning af register p pin***********************************************************
;	Fil:		Seriel test af byte 002.asm
;	Dato:		26-11-2017
;	forfatter:	Steen heide
; ****** BESKRIVELSE *******************************************************************
;   dette program anvendes til, at teste vrdien i et register for at finde ud af om programmet krer korrekt
;	Programmet udskriver registeret p PortA1 og udskriver et stttesignal p PortA0, s de enkelte bit kan ses
;   	PortA,0 og PortA1 skal sttes til udgange 
; ******* serielt test output start  ***  kan ikke anvendes til seriel kommunikation *******
TEST	;	setup i proceduren
			movwf	TESTvalue	; den byte der skal testes lgges i TESTvalue
			bsf		PORTA,0		; Trigger bit sttes
			movlw	d'9'		
			movwf	BYTE		; der er 8bit i en byte det holder Byte styr p
		;   Start seriel udskrivning af byte
nxt			BSF		PORTA,0
			bcf		STATUS,C
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			BCF		PORTA,0

			btfss	TESTvalue,0
			goto	skriv0		; der str 0 i carry ---> der skrives 0 i p PortA0
			goto	skriv1		; der str 1 i carry ---> der skrives 1 i p PortA0
			return

skriv0		BCF		PORTA,1
			rrf			TESTvalue,F	; TESTvalue roteres mod hjre og bit7 lgges i carry
			CALL		DELAY
			DECFSZ		BYTE,F
			GOTO		nxt
			RETURN	

skriv1		BSF		PORTA,1
			rrf		TESTvalue,F	; TESTvalue roteres mod hjre og bit7 lgges i carry
			CALL		DELAY
			DECFSZ	BYTE,F
			GOTO		nxt
			RETURN	
; ******* Delay start ***  tller delay ned 255 gange for hver gang der sendes en bit ****
DELAY		movlw	d'55'
			movwf tid
d			decfsz	tid
			goto	d
			RETURN

stop		Call DELAY
			Call DELAY
 			Call DELAY
	 		Call DELAY
			Call DELAY
			RETURN